use std::{fmt::Debug, num::ParseIntError};

trait MyTrait {
    type Ux: Copy;
    type T: Copy + TryFrom<Self::Ux> + Into<Self::Ux> + Debug;

    fn val(&self) -> Self::Ux;

    fn converted(&self) -> Self::T
    where
        <<Self as MyTrait>::T as std::convert::TryFrom<<Self as MyTrait>::Ux>>::Error:
            std::fmt::Debug,
    {
        self.val().try_into().unwrap()
    }
}

struct MyType1 {}

impl MyTrait for MyType1 {
    type Ux = u32;

    type T = u32;

    fn val(&self) -> Self::Ux {
        10
    }
}

struct MyType2 {}

#[derive(Debug, Clone, Copy)]
enum MyType2Val {
    A = 0x1,
    B = 0x2,
}

impl Into<u32> for MyType2Val {
    fn into(self) -> u32 {
        self as _
    }
}

impl TryFrom<u32> for MyType2Val {
    type Error = ParseIntError;

    fn try_from(value: u32) -> Result<Self, Self::Error> {
        match value {
            0x1 => Ok(MyType2Val::A),
            0x2 => Ok(MyType2Val::B),
            _ => panic!()
        }
    }
}

impl MyTrait for MyType2 {
    type Ux = u32;

    type T = MyType2Val;

    fn val(&self) -> Self::Ux {
        todo!()
    }
}

fn main() {
    println!("Hello, world!");
    
    let x = MyType1 {};
    println!("{}", x.converted());
}
